package jp.sagalab.skit;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import jp.sagalab.jftk.transform.TransformMatrix;

/**
 *
 * @author miwa
 */
public class BackGroundLayer extends Component{
	/** 背景画像 */
	private final BufferedImage m_image;
	/** モデル */
	private final ReadOnlySKITModel m_model;

	private BackGroundLayer( BufferedImage _image, ReadOnlySKITModel _model,int _width, int _height ) {
		m_image = _image;
		m_model = _model;
		setSize( _width, _height );
	}

	public static BackGroundLayer create( BufferedImage _image, ReadOnlySKITModel _model ) {
		return new BackGroundLayer( _image, _model, _image.getWidth(), _image.getHeight() );
	}

	@Override
	public void paint( Graphics _g ) {
		Graphics2D g = (Graphics2D) _g;
		drawBackGroundImage( g );
	}

	private void drawBackGroundImage( Graphics2D _g ) {
		TransformMatrix mat = m_model.getInitialViewToModel();
		TransformMatrix invMat = m_model.getViewToModel().inverse();
		mat = mat.product( invMat );
		_g.drawImage( m_image, toAffineTransform( mat ), null );
	}

	private static AffineTransform toAffineTransform( TransformMatrix _mat ) {
		return new AffineTransform(
			_mat.get( 0, 0 ), _mat.get( 1, 0 ),
			_mat.get( 0, 1 ), _mat.get( 1, 1 ),
			_mat.get( 0, 3 ), _mat.get( 1, 3 ) );
	}
}
