package jp.sagalab.skit;

/**
 * 入力デバイスの基底となるインタフェース
 * @author fujinaga
 */
public interface DeviceInterface {

    /** デバイス状態の更新 */
    public abstract void update ();

    /**
     * ボタン数の取得
     * @return ボタンの数
     */
    public abstract int getButtonsNum ();

    /**
     * ボタンの状態の取得
     * getButtonsNum()で得られる個数のボタンの状態を返す
     * @return ボタンの状態
     */
    public abstract boolean[] getButtonsState ();

    /**
     * 位置の取得
     * @return 位置
     */
    public abstract float[] getPosition ();

    /**
     * 姿勢の取得
     * @return 姿勢
     */
    public abstract float[] getOrientation ();
}
