package jp.sagalab.skit;

import jp.sagalab.jftk.Point;

/**
 * 入力専用モデルインタフェース。
 * @author oyoshi
 */
public interface InputOnlySKITModel {
	/**
	 * 入力点列を渡してModelに作用させる。
	 * @param _points 入力点列。
	 */
	void putPoints( Point[] _points );

	/**
	 * 指定した点に対してピッキング操作を行う。
	 * @param _point 入力点。
	 * @param _lpd 1デバイス単位あたりの長さ(cm)。
	 * @param _threshold ピッキング操作有効範囲(cm)。
	 */
	void picking( Point _point, double _lpd, double _threshold );

	/**
	 * 学習が実行中であれば、その学習を停止する。
	 */
	void cancelLearning();
}
