package jp.sagalab.skit;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.LinkedList;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;
import jp.sagalab.jflib.GestureRecognizer;
import jp.sagalab.jftk.Point;

/**
 * 入力点列の保存と読み込み
 * @author matsuura
 */
public class PointIOUtility {
	/**
	 * 点列を保存
	 * @param points 入力点列
	 */
	static void writePoints( Point[] points ) {
		DateFormat format = new SimpleDateFormat( "yyyy_MM_dd_HH_mm_ss_FFF" );
		String fileName = format.format( new Date() );
		try {
			//yyyy_MM_dd_HH_mm_ss_FFF.txtに出力
			PrintWriter pw = new PrintWriter(
				new BufferedWriter( new FileWriter ( new File( "." ).getAbsoluteFile().getParentFile().getParentFile().getParentFile().getParent()+"/"+fileName + ".txt" ) ) );
			// ストローク情報を格納
			for ( int i = 0; i < points.length; ++i ) {
				pw.println( points[i].x() + "," + points[i].y() + "," + points[i].z() + "," + points[i].time() );
			}
			pw.close();
		} catch ( IOException ex ) {
			Logger.getLogger( GestureRecognizer.class.getName() ).log( Level.SEVERE, null, ex );
		}
	}

	/**
	 * 点列の読み込み
	 * @param fileName ファイル名
	 * @return 入力点列
	 */
	public static Point[] readPoints( String fileName ) {
		Scanner sc;
		try {
			//sにファイル名を指定してください
			sc = new Scanner( new File( fileName ) );
		} catch ( FileNotFoundException ex ) {
			return null;
		}
		LinkedList<Point> readPoints = new LinkedList<Point>();
		while ( sc.hasNext() ) {
			String str = sc.next();
			String[] array = str.split( "," );
			double x = Double.parseDouble( array[0] );
			double y = Double.parseDouble( array[1] );
			double z = Double.parseDouble( array[2] );
			double t = Double.parseDouble( array[3] );
			Point p = Point.createXYZT( x, y, z, t );
			readPoints.add( p );
		}
		Point[] points = readPoints.toArray( new Point[ readPoints.size() ] );
		return points;
	}

	private PointIOUtility() {
		throw new UnsupportedOperationException();
	}
}
