package jp.sagalab.skit;

/**
 * ビューポート情報
 * @author hasegawa
 */
public class ViewportInfo {
	/** 始点X座標　*/
	private int m_x;
	/** 始点Y座標　*/
	private int m_y;
	/** 幅 */
	private int m_width;
	/** 高さ */
	private int m_height;

	public ViewportInfo() {
		m_x = 0;
		m_y = 0;
		m_width = 0;
		m_height = 0;
	}

	/**
	 * コンストラクタ
	 * @param _x
	 * @param _y
	 * @param _width
	 * @param _height
	 */
	public ViewportInfo( int _x, int _y, int _width, int _height ) {
		m_x = _x;
		m_y = _y;
		m_width = _width;
		m_height = _height;
	}

	/**
	 * 始点X座標の取得
	 * @return
	 */
	public int X() {
		return m_x;
	}

	/**
	 * 始点X座標の設定
	 * @param _x
	 */
	public void setX( int _x ) {
		m_x = _x;
	}

	/**
	 * 始点Y座標の取得
	 * @return
	 */
	public int Y() {
		return m_y;
	}

	/**
	 * 始点Y座標の設定
	 * @param _y
	 */
	public void setY( int _y ) {
		m_y = _y;
	}

	/**
	 * 幅の取得
	 * @return
	 */
	public int width() {
		return m_width;
	}

	/**
	 * 幅の設定
	 * @param _width
	 */
	public void setWidth( int _width ) {
		m_width = _width;
	}

	/**
	 * 高さの取得
	 * @return
	 */
	public int height() {
		return m_height;
	}

	/**
	 * 高さの設定
	 * @param _height
	 */
	public void setHeight( int _height ) {
		m_height = _height;
	}
}
