package jp.sagalab.skit.mulchitouchdevice;

/**
 * デバイスイベントを受け取るためのインタフェース。
 * @author nagase
 */
public interface MTDeviceListener {
    /**
     * デバイスプレスイベントへの対応。
     * デバイスのボタンを押したときに呼ばれる。
     * @param event デバイスイベント。
     */
    void devicePressed(MTDeviceEvent event);

    /**
     * デバイスムーブイベントへの対応。
     * デバイスの座標値を変更したときに呼ばれる。
     * @param event デバイスムーブイベント。
     */
    void deviceMoved(MTDeviceEvent event);

    /**
     * デバイスリリースイベントへの対応。
     * デバイスのボタンを離したときに呼ばれる。
     * @param event デバイスリリースイベント。
     */
    void deviceReleased(MTDeviceEvent event);
}
